/* 
 * File:   vmi_types.h
 * Author: springvesper@gmail.com
 *
 * Created on February  23, 2010, 2:47 PM
 */
#ifndef _VMI_TYPES_H
#define _VMI_TYPES_H

#ifdef	__cplusplus
extern "C" {
#endif

#include <X11/Xmd.h>
#include <X11/X.h>
#include <X11/Xlib.h>


#ifndef _D_DWORD
#define _D_DWORD
typedef CARD64 QWORD;
typedef CARD32 DWORD;
typedef CARD16 WORD;
typedef CARD16 SHORT;
typedef CARD8 BYTE;
#endif

#ifndef _D_ALIGN_TO
#define _D_ALIGN_TO
#define ALIGN_TO_8(f)             (((f) + 7) & ~7)
#define ALIGN_TO_16(f)            (((f) + 15) & ~15)
#define ALIGN_TO_32(f)            (((f) + 31) & ~31)
#define ALIGN_TO_64(f)            (((f) + 63) & ~63)
#define ALIGN_TO_128(f)           (((f) + 127) & ~127)
#define ALIGN_TO_256(f)           (((f) + 255) & ~255)
#endif


#ifndef  Ddmpeg_Status
typedef enum _Ddmpeg_Status {
	UnInitialized = 0x0,
	Allocated = 0x1,
	Prepared = 0x2,
	Locked = 0x4,
} Ddmpeg_Status;
#endif

#ifndef Success
#define Success 0
#endif

#ifndef Bool
#define Bool int
#endif 

#ifndef True
#define  True 1
#endif 

#ifndef False
#define False 0
#endif 

#ifndef Max
#define Max(a,b)  (((a) > (b)) ? (a) : (b))
#endif

#ifndef Min
#define Min(a,b)    (((a) < (b)) ? (a) : (b))
#endif

#ifndef Swap
#define Swap(a,b)  do { (a) = (a)^(b); (b) = (a)^(b); (a) = (a)^(b); } while(0)
#endif 


#ifdef	__cplusplus
}
#endif


#endif 	/*_VMI_TYPES_H*/
